package org.antlr.java.crossref;

/**
* A class for storing information about a class/field/method attribute.
* This class is usually only used for non-standard attributes.  Standard
* attributes such as SourceFile, Code, LineNumberTable, LocalVariableTable,
* Exceptions, and ConstantValue are handled with specialized methods in
* the appropriate Info class.
*
* @see KClassInfo
* @see KFieldInfo
* @see KMethodInfo
*/
public class KAttributeInfo {
	public String name;
	public byte[] data;

	public KAttributeInfo(String name, byte[] data) {
		this.name = name;
		this.data = data;
	}

	public String getName() {
		return name;
	}

	public byte[] getData() {
		return data;
	}
}
